attribute vec3 in_Position;
attribute vec3 in_Normal;
attribute vec2 in_TexCoord;

uniform mat4 u_MVPMatrix; // ModelViewProjection
uniform mat4 u_MVMatrix;  // ModelView
uniform mat3 u_NormalMatrix; // inverse ModelView

varying vec3 ex_E_Position;
varying vec3 ex_E_Normal;
varying vec2 ex_TexCoord;

void main()
{
	vec4 E_VertexPos = u_MVMatrix * vec4( in_Position, 1.0 );

	vec3 E_Normal = normalize( u_NormalMatrix * in_Normal );
	ex_E_Position = vec3(E_VertexPos);

	ex_E_Normal = E_Normal;
	ex_TexCoord = in_TexCoord;
	
	gl_Position = u_MVPMatrix * vec4( in_Position, 1.0 );
}